<?php
session_start();
if (empty($_SESSION['uid'])) {
    header("Location: index.php");
}
include "config.php";
include "functions.php";
if ($user['room'] != 30) {
    header("Location: main.php");
}

//$klanName = filter_input(INPUT_POST, 'klanname');
//$klanAbbr = filter_input(INPUT_POST, 'klanabbr');
//$klanDescr = filter_input(INPUT_POST, 'klandescr');
$klanName = $_POST['klanname'] ?? '';
$klanAbbr = $_POST['klanabbr'] ?? '';
$klanDescr = $_POST['klandescr'] ?? '';

?>
<!doctype html>
<html lang="ru">
<head>
    <link rel=stylesheet href="css/main.css">
    <meta charset="utf-8">
    <script>
        function leave() {
            top.frames['main'].location = 'city.php?strah'
        }
    </script>
    <title>Регистратура кланов</title>
</head>
<body>
<h1>Регистратура кланов</h1>
<a href=# onclick=leave()> ← выйти из регистратуры</a>
<?php
if ($klanName && $klanAbbr && $klanDescr) {

    $eff = db::c()->query('SELECT 1 FROM `effects` WHERE `owner` = ?i AND `type` = 20', $user['id']);
    $name_check = db::c()->query('SELECT 1 FROM `clans` WHERE `name` = "?s" OR `short` = "?s"', 111, 333);

    if (!empty($user['align'])) {
        $error .= 'Вы уже имеете направленность!. <BR>';
    }
    if (!empty($user['klan'])) {
        $error .= 'Вы уже состоите в клане!. <BR>';
    }
    if (10000 >= $user['money']) {
        $error .= 'Не хватает денег на регистрацию клана. <BR>';
    }
    if (!$eff) {
        $error .= 'Нет проверки. <BR>';
    }
    if (!$name_check) {
        $error .= 'Клан с такими данными уже существует.<br>';
    }

    if (!$error) {
        /*TODO: Класс банковского перевода.*/
//        db::c()->query('INSERT INTO `reg_klan` (owner, name, abr, descr) VALUES (?i,"?s","?s","?s")',
//            $user['id'], $klanName, $klanAbbr, $klanDescr);
//        db::c()->query('UPDATE `users` SET `money` = `money` - 10000 WHERE `id` = ?i', $user['id']);
//        err('Вам прийдет извещение о результате регистрации клана.');
        err('Проверки пройдены, но клан регистрировать пока нельзя!');
    } else {
        err($error);
    }
}

if ($user['admin'] == '1') {
    $clanreg = db::c()->query('SELECT `date`,`name`,`abbr`,`owner`,`descr` FROM `reg_klan`');
    echo '<table>';
    while ($clanreg_row = $clanreg->fetch_assoc()) {
        echo "<TR>
            <TD>", $clanreg_row['date'], "</TD>
            <TD>", $clanreg_row['name'], "</TD>
            <TD>", $clanreg_row['abbr'], "</TD>
            <TD>", nick::id($clanreg_row['owner'])->full(), "</TD>
            <TD>", nl2br($clanreg_row['descr']), "</TD>
          </TR>";
    }
    echo '</table>';
}
?>
Для регистрации клана необходимо иметь:
<ol>
    <li>Проверку на чистоту.
    <li>10000 кредитов на банковском счёте.
</ol>
Поле информации не обазательное. Но его содержимое может серьёзно повысить шансы на регистрацию клана.<BR>
Заявку на регистрацию подает глава клана.
<form method="post">
    <fieldset style="display: inline;">
        <legend>Заявка на регистрацию</legend>
        <input size=30 name="klanname" placeholder="Название клана" value="<?= $klanName ?>">
        <input size=30 name="klanabbr" placeholder="Английская аббревиатура" value="<?= $klanAbbr ?>"><BR>
        <BR>
        <textarea cols=80 rows=10 name="klandescr"
                  placeholder="Информация о клане для энциклопедии"><?= nl2br($klanDescr) ?></textarea><BR>
        <input type="submit" value="Подать заявку">
    </fieldset>
</form>
</body>
</html>