<?php
/**
 * Author: lopiu
 * Date: 04.07.2020
 * Time: 11:10
 */



trait Rooms
{
    /**
     * Возвращает имя комнаты по её ID.
     * @param $room_id - ID комнаты.
     * @return string
     */
    public function getRoomName($room_id)
    {
        switch ($room_id) {
            default:
                $this->roomname = "Неизвестная локация";
                break;
            case 1:
                $this->roomname = "Дом поединков";
                break;
            case 20:
                $this->roomname = "Центральная площадь";
                break;
            case 21:
                $this->roomname = "Страшилкина улица";
                break;
            case 22:
                $this->roomname = "Магазин";
                break;
            case 23:
                $this->roomname = "Ремонтная мастерская";
                break;
            case 24:
                $this->roomname = "Памятник Архангелу";
                break;
            case 25:
                $this->roomname = "Комиссионный магазин";
                break;
            case 26:
                $this->roomname = "Большая парковая улица";
                break;
            case 27:
                $this->roomname = "Почта";
                break;
            case 28:
                $this->roomname = "Регистратура кланов";
                break;
            case 29:
                $this->roomname = "Банк";
                break;
        }
        return $this->roomname;
    }
}